<?PHP
//--------------------------------------------------
//                Mysynx Ver 0.7
//       For MYSQL 4.0/4.1 & PHP 4.X.X
//          Copyright (C)2005 S.Dozono
//         Published under LGPL Licence.
//--------------------------------------------------
/* usage: ******************************************

	You can synchronize(or replicate) slave servers
	by just adding "$mySynx->" to mysql_query()!

	files:
		mysynx.php			main file
		mysynx_tunnel.php	HTTP tunneling file

	in your script:

	Require_once("mysynx.php");
	 :
	 :
	//Slave MYSQL1
	$opt[0]['host'] =       "localhost"; //host
	$opt[0]['name'] =       "root"; //MYSQL Username
	$opt[0]['password'] =   "root"; //password for MYSQL
	$opt[0]['db'] =         "test_table"; //Database name
	$opt[0]['tunnelURL'] =  ""; //Tunneling phpfile URL
	
	//Slave MYSQL2
	$opt[1]['host'] = 		"localhost";
	$opt[1]['name'] = 		"loginname";
	$opt[1]['password'] =	"password";
	$opt[1]['db'] =			"test_table";
	$opt[1]['tunnelURL'] = 	"http://www.example.com/mysynx_tunnel.php"; //If you like. :-)
	 :
	
	Then, in your php script....
	
	$mySynx = new mySynx($opt);

	Adjust
     mysql_query($query, $link); -> $mySynx->mysql_query($query, $link);
     mysql_query($query);        -> $mySynx->mysql_query($query);
     mysql_db_query($query, $link); -> $mySynx->mysql_db_query($query, $link);

************************************************* */

//Settings..

//define ( "DEBUG", 1 ); //for Debug log
define ( "TUNNELKEY", "abcde"); //for Tunnel Password

/* Template.

Require_once("mysynx.php");

//slave 1.
$opt[0]['host'] = 		"localhost";
$opt[0]['name'] = 		"root";
$opt[0]['password'] =	"root";
$opt[0]['db'] =			"test";
$opt[0]['tunnelURL'] = 	"";

//slave 1.
$opt[0]['host'] = 		"localhost";
$opt[0]['name'] = 		"root";
$opt[0]['password'] =	"root";
$opt[0]['db'] =			"test";
$opt[0]['tunnelURL'] = 	"http://yourdomain/mysynx_tunnel.php";

$mySynx = new mySynx($opt);

*/

class mySynx
{
	
	var $host;
	var $name;
	var $db;
	var $password;
	var $tunnelURL;

	//constructor
	function mySynx($opt){
		for($i=0; $i<count($opt);$i++){
			$this->host[$i] = $opt[$i]['host'];
			$this->name[$i] = $opt[$i]['name'];
			$this->db[$i] = $opt[$i]['db'];
			$this->password[$i] = $opt[$i]['password'];
			$this->tunnelURL[$i] = $opt[$i]['tunnelURL'];
		}
	}

	//If Debug mode, log all the information.
	function saveLog($text){
		if(defined("DEBUG")){
			$nowtime = date("Y-m-d/G:i:s ",time());
			$fp=@fopen("mySynx.log","a");
			if($fp==FALSE){
				return;
			}
			@fwrite($fp,$nowtime.$text."\n");
			@fclose ($fp);
		}
	}
	
	//log errors.
	function save_errLog($text){
		$nowtime = date("Y-m-d/G:i:s ",time());
		$fp2=@fopen("mySynx_err.log","a");
		if($fp2==FALSE){
			return;
		}
		@fwrite($fp2,$nowtime.$text."\n");
		@fclose ($fp2);
	}

	//main function.. PHP Script will call this.
	function mysql_query($query, $link=''){
		
		//MASTER MYSQL
		if($link != ''){
			$master_rs = $this->master_query($query, $link);
		} else {
			$master_rs = $this->master_query2($query);
		}
		
		//SLAVE MYSQLs
		if($this->isNeeded($query)){
			for($i=0; $i<count($this->host);$i++){
				if(strlen($this->tunnelURL[$i])){
				
					$slave_rs=$this->tunnelQuery(
								 $this->tunnelURL[$i],
								 $this->host[$i],
								 $this->name[$i],
								 $this->password[$i],
								 $this->db[$i],
								 $query);
				} else {

					$slave_rs=$this->slave_query(
								$this->host[$i],
								$this->name[$i],
								$this->password[$i],
								$this->db[$i],
								$query);
				}
			}
		}
		return $master_rs;
	}
	
	function mysql_db_query($database, $query, $link=''){

		//MASTER MYSQL
		mysql_select_db($database);
		$this->saveLog("Master database: ".$database);
		if($link != ''){
			$master_rs = $this->master_query($query, $link);
		} else {
			$master_rs = $this->master_query2($query);
		}
		
		//SLAVE MYSQLs
		if($this->IsNeeded($query)){
			for($i=0; $i<count($this->host);$i++){

				if(strlen($this->tunnelURL[$i])){
				
					$slave_rs=$this->tunnelQuery(
								 $this->tunnelURL[$i],
								 $this->host[$i],
								 $this->name[$i],
								 $this->password[$i],
								 $this->db[$i],
								 $query);
				} else {

					$slave_rs=$this->slave_query(
								$this->host[$i],
								$this->name[$i],
								$this->password[$i],
								$this->db[$i],
								$query);
				}
			}
		}
		return $master_rs;
	}
	
	//Internal for Original Query.
	function master_query($query, $link){
		$rs=mysql_query($query, $link);
		if($rs==FALSE){
			save_errLog("[master] ".mysql_errorno().": ".mysql_error());
			die;
		}
		$this->saveLog("master: ".$query);
		return $rs;
	}

	function master_query2($query){
		$rs=mysql_query($query);
		if($rs==FALSE){
			save_errLog("[master] "." ".mysql_errorno().": ".mysql_error());
			die;
		}
		$this->saveLog("master2: ".$query);
		return $rs;
	}
	
	//Internal for Slave MYSQL's Queries.
	function slave_query($host, $name, $password, $db, $query){

		$db_res=@mysql_connect($host, $name, $password);
		if($db_res==FALSE){
			$this->save_errLog("Error: can't connect to ".$host);
			return FALSE;
		}
		
		$sel_db = @mysql_select_db($db,$db_res);
		if($sel_db==FALSE){
			$this->save_errLog("Error[".$host."]: can't select ".$db);
			return FALSE;
		}
		
		$rs=@mysql_query($query, $db_res);
		if($rs==FALSE){
			$this->save_errLog("Error[".$host."]: Query Error".mysql_errno()."/".mysql_error());
			return FALSE;
		}
		$this->saveLog("slave[".$host."]: ".$query);
		return $rs;
	}

	//Needed SQL Query for Slaves?
	function isNeeded($query)
	{
		$flag = TRUE;
		if(eregi("^SELECT ",$query)){
			$flag = FALSE;
		}
		return $flag;
	}
	
	//Tunneling Function
	function tunnelQuery( $url, $sql_host, $sql_name, $sql_password, $sql_db, $sql_query){

		$port = 80;
		$post = " "."host=".  rawurlencode($sql_host);
		$post.= "&"."name=".  rawurlencode($sql_name);
		$post.= "&"."pass=".  rawurlencode($sql_password);
		$post.= "&"."db=".    rawurlencode($sql_db);
		$post.= "&"."query=". rawurlencode($sql_query);
		$post.= "&"."key=".   rawurlencode(TUNNELKEY);
		$post.= "&"."mySynx=1";

		$p_url = parse_url($url);

		$p_query = '';
		if(isset($p_url['query'])){
			$p_query = $p_url['query'];
		}
		
		if(isset($p_url['port'])){
			$port = $p_url['port'];
		}
		
		$host = $p_url['host'];
		
		// HTTP REQUEST
		$data  = "POST ".$p_url['path'].$p_query." HTTP/1.0\r\n";
		$data .= "Host: ".$host."\r\n";
		$data .= "User-Agent: PHP/".phpversion()."\r\n";
		$data .= "Content-type: application/x-www-form-urlencoded\r\n";
		$data .= "Connection: close\r\n";
		$data .= "Content-Length: ".strlen($post)."\r\n\r\n";
		$data .= $post."\r\n";
		$data .= "\r\n";
		
		//echo "host=".$host."<BR>";
		//echo "port=".$port."<BR>";
		//echo "data=".$data."<BR>";
		//echo "<HR>";
		//die;
		
		// open socket
		$fn = fsockopen( $host, $port, $errno, $errstr, 10);
		if($fn==FALSE){
			$this->save_errLog("Tunnel fsockopen Error[".$host."]: ".$errstr."(".$errno.") Check Tunnel URL.");
			return FALSE;
		}
		// send
		if( fputs($fn,$data)==FALSE ){
			$this->save_errLog("Tunnel fputs Error[".$host."]: ".$errstr."(".$errno.") Check Tunnel URL.");
			return FALSE;
		};
		// receive
		$res = "";
		$flag= "";
		while(!feof($fn)){
			$retval = fgets($fn);
			if( $retval==FALSE){
				$this->save_errLog("Tunnel fgets Error[".$host."]: ".$errstr."(".$errno.") Check Tunnel URL.");
				return FALSE;
			};
			$res=$res.$retval;
		}
		if( fclose($fn)== FALSE){
			$this->save_errLog("Tunnel fclose Error[".$host."]: ".$errstr."(".$errno.") Check Tunnel URL.");
			return FALSE;
		};
		$this->saveLog("tunnel[".$p_url['host']."]: ".$res);
		//$this->saveLog("tunnel[".$p_url['host']."]: ".$query);
		return $res;
	}
}

?>