<?PHP
//--------------------------------------------------
//            Mysynx tunneling file
//      <<< TunnelQuery Script Ver 0.7>>>
//        For MYSQL 4.0/4.1 & PHP 4.X.X
//         Copyright (C)2005 S.Dozono
//        Published under LGPL Licence.
//--------------------------------------------------

//Settings..

//define ( "DEBUG", 1 ); //for Debug log
define ( "TUNNELKEY", "abcde"); //for Tunnel Password

if(   isset($_POST['mySynx'])
   && isset($_POST['host'])
   && isset($_POST['name'])
   && isset($_POST['pass'])
   && isset($_POST['db'])
   && isset($_POST['query'])
   && isset($_POST['key'])
){
	if($_POST['key']==TUNNELKEY){
		$tQuery = new tQuery(
					$_POST['host'],
					$_POST['name'],
					$_POST['pass'],
					$_POST['db'],
					$_POST['query']
					);
	}
} else {
	echo "URL-OK.";
}

//Tunneling Query Over HTTP:

class tQuery{
	
	var $host;
	var $name;
	var $password;
	var $db;
	var $query;

	function tQuery($host, $name, $pass, $db, $query){

		$this->host = 		rawurldecode($host);
		$this->name = 		rawurldecode($name);
		$this->password = 	rawurldecode($pass);
		$this->db =   		rawurldecode($db);
		$this->query = 		rawurldecode($query);

		$rs = $this->myQuery($this->host, $this->name, $this->password, $this->db, $this->query);
		$this->putRetVal($rs);
	}

	function putRetVal($text){
		echo $text;
	}

	function myQuery($host, $name, $password, $db, $query){

		$db_res=@mysql_connect($host, $name, $password);
		if($db_res==FALSE){
			$this->save_errLog("Error: can't connect to ".$host."/".$name."/".$password);
			return FALSE;
		}
		
		$sel_db = @mysql_select_db($db,$db_res);
		if($sel_db==FALSE){
			$this->save_errLog("Error[".$host."]: can't select ".$db);
			return FALSE;
		}

		$this->setName($host, $name, $password, $db);
		
		$rs=@mysql_query($query, $db_res);
		if($rs==FALSE){
			$this->save_errLog("Error[".$host."]: Query Error".mysql_errno()."/".mysql_error());
			return FALSE;
		}
		$this->saveLog("tunnel[".$host."]: ".$query);
		return TRUE;

	}

	function saveLog($text){
		if(defined("DEBUG")){
			$nowtime = date("Y-m-d/G:i:s ",time());
			$fp=@fopen("mysynx_tunnel.log","a");
			if($fp==FALSE){
				return;
			}
			@fwrite($fp,$nowtime.$text."\n");
			@fclose ($fp);
		}
	}
	
	//log errors.
	function save_errLog($text){
		$nowtime = date("Y-m-d/G:i:s ",time());
		$fp2=@fopen("mysynx_tuerr.log","a");
		if($fp2==FALSE){
			return;
		}
		@fwrite($fp2,$nowtime.$text."\n");
		@fclose ($fp2);
	}

	function setName(){
		$query = "SHOW variables like 'character_set_database' ";
		$result = @mysql_query($query);
		$charsets = array();
		while($row = @mysql_fetch_array($result)){
			$charsets[$row['Variable_name']]= $row['Value'];
		}
		
		$db_database = $charsets['character_set_database'];

		if( strlen($db_database)){
			$query = "SET NAMES ".$db_database; //FOR MYSQL 4.1 or later.
			@mysql_query ($query);
			$this->saveLog("tunnel: ".$query);
		}
	}

}


?>